// CfgPage.cpp : implementation file
//
// CrackUp version 1.0
// Copyright  1998 Ziff-Davis, Inc.
// First published in PC Magazine, US Edition, November 3, 1998
// Written by Bob Flanders and Gregory A. Wolking

#include "stdafx.h"
#include "crackup.h"
#include "CfgPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern BOOL g_bPopup, g_bBackground, g_bMessageActive, g_bScanInProgress, g_bStopScanNow;
extern WORD g_wMaxFrag, g_wScanInterval, g_wNDrives, g_wHoursLeft, g_wTimeTicks, g_wNDrivesSelected;
extern DRVTABENT g_stDrvTbl[MAXDRIVES];
extern int g_intFormula;
extern void WriteProfile(void);
extern HWND g_hMasterWindow;

/////////////////////////////////////////////////////////////////////////////
// CCfgPage property page

IMPLEMENT_DYNCREATE(CCfgPage, CPropertyPage)

CCfgPage::CCfgPage() : CPropertyPage(CCfgPage::IDD)
{
	//{{AFX_DATA_INIT(CCfgPage)
	m_bBackground = FALSE;
	m_bPopup = FALSE;
	m_intFragPercent = 0;
	m_intDelay = 0;
	m_intFormula = -1;
	//}}AFX_DATA_INIT
	m_bSettingsChanged = FALSE;
}

CCfgPage::~CCfgPage()
{
}

void CCfgPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCfgPage)
	DDX_Control(pDX, IDC_lblDelay1, m_lblDelay1);
	DDX_Control(pDX, IDC_lblCalc, m_lblCalc);
	DDX_Control(pDX, IDC_lblTime2, m_lblTime2);
	DDX_Control(pDX, IDC_lblTime1, m_lblTime1);
	DDX_Control(pDX, IDC_optFormula1, m_optFormula1);
	DDX_Control(pDX, IDC_optFormula2, m_optFormula2);
	DDX_Control(pDX, IDC_lblPercent, m_lblPercent);
	DDX_Control(pDX, IDC_txtDelay, m_txtDelay);
	DDX_Control(pDX, IDC_txtPercent, m_txtPercent);
	DDX_Control(pDX, IDC_lstCfgDrives, m_lstCfgDrives);
	DDX_Check(pDX, IDC_chkBackground, m_bBackground);
	DDX_Check(pDX, IDC_chkPopup, m_bPopup);
	DDX_Text(pDX, IDC_txtPercent, m_intFragPercent);
	DDV_MinMaxUInt(pDX, m_intFragPercent, 0, 99);
	DDX_Text(pDX, IDC_txtDelay, m_intDelay);
	DDX_Control(pDX, IDC_lblDelay, m_lblDelay);
	DDX_Radio(pDX, IDC_optFormula1, m_intFormula);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCfgPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCfgPage)
	ON_BN_CLICKED(IDC_chkBackground, OnCheckBackground)
	ON_EN_CHANGE(IDC_txtPercent, OnChangeEditPercent)
	ON_EN_CHANGE(IDC_txtDelay, OnChangeEditTimer)
	ON_BN_CLICKED(IDC_chkPopup, OnCheckPopup)
	ON_BN_CLICKED(IDC_optFormula1, OnoptFormula1)
	ON_BN_CLICKED(IDC_optFormula2, OnoptFormula1)
	//}}AFX_MSG_MAP
	ON_CONTROL(CLBN_CHKCHANGE, IDC_lstCfgDrives, OnListBoxCheck)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCfgPage message handlers

BOOL CCfgPage::OnInitDialog() 
{
	PDRVTABENT	pD;
	WORD wI;
	char szW[10];

	CPropertyPage::OnInitDialog();
	m_bNoQueryScan = FALSE;

	// Load member variables from globals.
	m_bDrivesChanged = FALSE;
	m_intFragPercent = g_wMaxFrag;
	m_bPopup = g_bPopup;
	m_bBackground = g_bBackground;
	m_intDelay = g_wScanInterval;
	// Load drive check list.
	for (wI = 0; wI < g_wNDrives; wI++)			// for each drive found ..
	{
		pD = &g_stDrvTbl[wI];					// save drive table entry
		sprintf(szW, "%c:", pD->cDrv & 0x5f);	// build drive id	
		m_lstCfgDrives.AddString(szW);			// .. and put in box
		m_lstCfgDrives.SetCheck					// set up that item
				(m_lstCfgDrives.GetCount() - 1,	// .. with the current setting
				 pD->bCheckDrive);				// .. from the drive table
	}
	// Transfer data to the window controls.
	m_intFormula = g_intFormula;
	UpdateData(FALSE);
	// Enable/disable edit controls appropriately.
	m_txtDelay.EnableWindow(m_bBackground);
	m_lblTime1.ShowWindow(m_bBackground ? SW_SHOW : SW_HIDE);
	m_lblTime2.ShowWindow(m_bBackground ? SW_SHOW : SW_HIDE);
	m_txtPercent.EnableWindow(m_bPopup);
	if (m_bPopup)
	{
		m_lblPercent.SetWindowText("% &fragmentation");
		m_lblCalc.SetWindowText("&calculated using");
	}
	else
	{
		m_lblPercent.SetWindowText("% fragmentation");
		m_lblCalc.SetWindowText("calculated using");
	}
	m_optFormula1.EnableWindow(m_bPopup);
	m_optFormula2.EnableWindow(m_bPopup);
	return TRUE;
}

BOOL CCfgPage::OnApply() 
{
	if (g_bScanInProgress)
	{
		if (!m_bNoQueryScan)		// Means we're being called by CCUSheet::OnExit()
									// which has already set flag to stop any scan in progress.
		{
			g_bMessageActive = TRUE;
			MessageBox("Cannot save settings with scan in progress.", "CrackUp Error", MB_OK);
			g_bMessageActive = FALSE;
			return FALSE;
		}
	}
	return CPropertyPage::OnApply();
}

void CCfgPage::OnOK() 
{

	// Nothing to do if settings haven't changed.
	if (m_bSettingsChanged)	
	{
		int i;
		PDRVTABENT pD;

		if (g_bScanInProgress && !m_bNoQueryScan)	// If a scan is working,
		{
			g_bMessageActive = TRUE;		// Can't update drive table!
			MessageBox("Cannot save settings while scan is in progress.", "CrackUp Notice", MB_OK);
			g_bMessageActive = FALSE;
			return;
		}
		// If timer settings have changed,
		if ((m_bBackground != g_bBackground) || (g_wScanInterval != m_intDelay))
		{
			// Update the globals and reset the timer.
			g_wScanInterval = g_wHoursLeft = (WORD) m_intDelay;
			g_wTimeTicks = 360;
			g_bBackground = m_bBackground;
			ShowTimeLeft();
		}
		// Transfer remaining local settings to global storage.
		g_wMaxFrag = (WORD) m_intFragPercent;
		g_bPopup = m_bPopup;
		g_wNDrivesSelected = 0;
		for (i = 0; i < g_wNDrives; i++)
		{
			pD = &g_stDrvTbl[i];
			pD->bCheckDrive = m_lstCfgDrives.GetCheck(i);
			if (pD->bCheckDrive)
				++g_wNDrivesSelected;
			g_intFormula = m_intFormula;
		}
		// Write the ini file.
		WriteProfile();
		// If drive settings were changed, ask user if he wants to re-scan.
		if (!m_bNoQueryScan)
		{
			if (m_bDrivesChanged)
			{
				g_bMessageActive = TRUE;
				i = MessageBox("Your drive settings have changed\n"
					"Do you wish to scan them now?","CrackUp Notice", MB_YESNO | MB_ICONQUESTION);
				g_bMessageActive = FALSE;
				// If he said yes, tell main window to start the scan.
				if (i == IDYES)
				{
					m_bDrivesChanged = FALSE;
					::PostMessage(g_hMasterWindow, WM_COMMAND, ID_SCANNOW, 0);
				}
			}
		}
		// Reset flag.
		m_bSettingsChanged = FALSE;
	}
	CPropertyPage::OnOK();
}


///////////////////
// Control event handlers
/////////////////// 

// "Background" checkbox.
void CCfgPage::OnCheckBackground() 
{
	UpdateData(TRUE);
	m_txtDelay.EnableWindow(m_bBackground);
	m_lblTime1.ShowWindow(m_bBackground ? SW_SHOW : SW_HIDE);
	m_lblTime2.ShowWindow(m_bBackground ? SW_SHOW : SW_HIDE);
	ShowTimeLeft();
	CompareSettings();
}

// "Frag level" edit control.
void CCfgPage::OnChangeEditPercent() 
{
	if (UpdateData(TRUE))
		CompareSettings();
}

// "Hours between scans" edit control.
void CCfgPage::OnChangeEditTimer() 
{
	if (UpdateData(TRUE))
		CompareSettings();
}

// "Popup warning" checkbox.
void CCfgPage::OnCheckPopup() 
{
	if (UpdateData(TRUE))
	{
		m_txtPercent.EnableWindow(m_bPopup);
		if (m_bPopup)							// If setting is on,
		{
			m_lblPercent.SetWindowText("% &fragmentation");	// Enable activation letters.
			m_lblCalc.SetWindowText("&calculated using");
		}
		else												// Otherwise,
		{
			m_lblPercent.SetWindowText("% fragmentation");	// Disable activation letters.
			m_lblCalc.SetWindowText("calculated using");
		}
		m_optFormula1.EnableWindow(m_bPopup);
		m_optFormula2.EnableWindow(m_bPopup);
		CompareSettings();
	}
}

// Check box in list changed state.
void CCfgPage::OnListBoxCheck()
{
	CompareSettings();
}

// Called whenever user changes the value in any control.
// Used to enable/disable the Apply button, also to
// signal whether or not user changed his drive selection.
void CCfgPage::CompareSettings()
{
	m_bDrivesChanged = FALSE;					// Drive status change defaults to FALSE;
	if (g_intFormula != m_intFormula)			// Formula changed?
		m_bDrivesChanged = TRUE;				// No need to check individual drives.
	else										// Otherwise,
	{
		for (int i = 0; i < g_wNDrives; i++)		// For each drive,
		{
			if (m_lstCfgDrives.GetCheck(i) != g_stDrvTbl[i].bCheckDrive)	// Check selection state
			{
				m_bDrivesChanged = TRUE;			// Set flag if no match.
				break;
			}
		}
	}
	// Check other settings and combine with drive setting change.
	m_bSettingsChanged = (m_bDrivesChanged ||
						(m_intFragPercent	!= g_wMaxFrag) ||
						(m_intDelay			!= g_wScanInterval) ||
						(m_bPopup			!= g_bPopup) ||
						(m_bBackground		!= g_bBackground));
	// Enable or disable the "Apply" button appropriately.
	SetModified(m_bSettingsChanged);
}

void CCfgPage::OnoptFormula1() 
{
	if (UpdateData(TRUE))
		CompareSettings();
}

// Called when this page is activated.
BOOL CCfgPage::OnSetActive() 
{
	int iIndex;

	iIndex = m_lstCfgDrives.GetCurSel();	// Get current selection.
	if (iIndex == LB_ERR)					// If none,
		m_lstCfgDrives.SetCurSel(0);		// Select first item.
	if (m_bBackground)						// If background box is checked,
		ShowTimeLeft();						// Update time display.
	return CPropertyPage::OnSetActive();	// Let MFC do its thing.
}

// Updates the "time remaining until next scan" display.
void CCfgPage::ShowTimeLeft()
{
	CString strTime;
	WORD wHours = 0;
	WORD wMins = 0;
	WORD wSecs = 0;

	if (!m_bBackground)
		return;
	if (g_wHoursLeft > 0)
		wHours = (WORD) (g_wHoursLeft - 1);
	if (g_wTimeTicks < 360)
	{
		wMins = (WORD) (g_wTimeTicks / 0x6);
		wSecs = (WORD) ((g_wTimeTicks % 0x6) * 0xA);
	}
	else
		++wHours;
	strTime.Format("%u:%02u:%02u", wHours, wMins, wSecs);
	m_lblTime2.SetWindowText(strTime);
}
